# JTL4 Plugin

**Shopversion:** 
JTL Shop 4.x.x

**Also needed:** 

**Module Path:** 
/includes/plugins/micropayment/

**Specials:** 
none

---

## ChangeLog

v1.0.3

* added 3D Secure switches
* added new core 1.2.8
* added update checker
* added expire days for prepayment
* fixed error 32 issue in 4.0.6

v1.0.2

* fixed testmode issue

v1.0.1

* fixed session id length issue

v1.0.0

* First version of plugin with paymethods: 
 - creditcard
 - sepa
 - prepayment
 - all web api payments


## Merchant Setup


#### Project Setup
1. Setup project as usual.
2. Fill all fields and save the project.
3. After creation click again on new project row.
4. Copy and remember the project shortcut. (Kürzel)
5. We need this in the plugin later.

#### CreditCard API.Event
1. The only thing to setup is the Notify URL.
 
	Please set this to:

	https://shopurl.de/root-of-shop/mcpayResponse
	
2. Click on **Read information on using the API** and mark the checkbox.
3. Click on **Save settings** and you are done.
4. Thats all for this paymethod.
	
#### Sepa API.Event
1. The only thing to setup is the Notify URL.
 
	Please set this to:

	https://shopurl.de/root-of-shop/mcpayResponse
	
2. Click on **Read information on using the API** and mark the checkbox.
3. Click on **Save settings** and you are done.
4. Thats all for this paymethod.

#### PrePay API.Event
1. The only thing to setup is the Notify URL.
 
	Please set this to:

	https://shopurl.de/root-of-shop/mcpayResponse
	
2. Click on **Read information on using the API** and mark the checkbox.
3. Click on **Save settings** and you are done.
4. Thats all for this paymethod.


#### Sofort. Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/mcpayResponse?ph=__$ph__&sh=__$sh__&orderid=__$orderid__
	
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### PayPal Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/mcpayResponse?ph=__$ph__&sh=__$sh__&orderid=__$orderid__&transactionId=__transactionId__
			
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### PaySafeCard Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/mcpayResponse?ph=__$ph__&sh=__$sh__&orderid=__$orderid__
		
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### Call2Pay Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/mcpayResponse?ph=__$ph__&sh=__$sh__&orderid=__$orderid__
		
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### HandyPay Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/mcpayResponse?ph=__$ph__&sh=__$sh__&orderid=__$orderid__
		
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.

#### PayDirekt Event
1. Here we need the API URL and some additional parameters.
2. Mark the checkbox **Activate payment method for XXXX**
3. Now the **API-URL** and the **Additional parameters**.
4. With a little trick we can handle this very easy.
5. Please copy this URL to **API-URL** and click on **Save settings**.

	https://shopurl.de/root-of-shop/mcpayResponse?ph=__$ph__&sh=__$sh__&orderid=__$orderid__
			
	It will give you an error like:
**An error has occurred. We were unable to process your data**
and the field is marked as **Additional GET parameter contain invalid characters** but it will setup all needed parameters at once. 

6. Just another click on **Save settings** and you are done.



#### Get Access Key
1. Click on **Setup** in the top navi and then click on **Accessskey**.
2. Copy this hash and remember it for the plugin later.
3. Setup is done so far.

---

## Installing and configure the plugin
1. First of all, login into your admin area and goto **Plugins** -> **Pluginverwaltung** 
2. Click on **Upload** and select the ZIP Plugin file and upload it.
3. Now the plugin is shown under **Verfügbar**
4. Select the plugin and click on **Installieren**
5. Under **Plugins** -> **Micropayment Plugin** you can configure basic settings of the plugin.
6. The payment specific settings can be found under **Storefron** -> **Zahlungsarten** -> **Übersicht**
7. Click on the wanted paymethod edit icon on the right and configure like you want.
8. After that you need to add the paymethods to a shipping method. Goto **Storefront** -> **Kaufabwicklung** -> **Versandarten** and add the paymethods to each shipping method you want.
5. Thats it.

### Alternative / manual Way
1. copy the content of the plugin.zip via ftp uncompressed into the root of your shop. The plugin files and directories will be copied into the right place. Nothing will be overwritten.
2. Login into your Admin area.
3. Look at normal way Step 3. and following

---

## Test Credentials
#### VISA
	Number: 4111111111111111 
	CVV: 666 (success) with 3D Secure
	or
	CVV: 999 (success) without 3D Secure
	Date: something in future
	
#### MASTERCARD
	Number: 5105105105105100
	CVV: 666 (success) with 3D Secure
	or
	CVV: 999 (success) without 3D Secure
	Date: something in future

#### SEPA
	IBAN: DE89888888881234567890
	BIC: TESTDE00XXX
	Owner: Firstname Lastname

#### SOFORT
	BLZ: 88888888
	KTO: 1234567890
	PIN: 1234
	TAN: 12345
	
#### PREPAY
	Nothing special is needed.
	
#### PAYSAFECARD
	Nothing special is needed.
	
#### PAYDIREKT
	Amount:
	1-3 Euro		Successful with two factor auth
	4 - 500 Euro	Successful without two factor auth
	> 500 Euro	Failed
	
	Two Factor Auth:
	TAN:	123456
	
	User:	micropayment_SDE-Kaeufer 	
	Pass:	SDE-Kaeufer2$ 	
	Desc:	Success < 500 Euro

	User:	micropayment_unterAchtzehn
	Pass:	unterAchtzehn2$
	Desc:	Failed if customer age verification is set to over 18
	
	User:	micropayment_SperreKB
	Pass:	SperreKB2$
	Desc:	Failed due to issuing bank
	
#### PAYPAL
	You will need a special PayPal Sandbox account.
	Please contact our support.

#### CALL2PAY
	Nothing special is needed.
	
#### HANDYPAY
	PhoneNo. 88888888
	SMS-Code: 666
	
## FAQ

	Q: ...
	A: ...