<?php
$path = str_replace('\\', '/', dirname(__FILE__));
$basePath = strstr($path, '/includes/plugins/', true);
$bootstrapper = $basePath.'/includes/globalinclude.php';

$exit = function ($error = false) {
  ob_end_clean();
  http_response_code(($error !== true) ? 200 : 503);
  exit;
};

if (!file_exists($bootstrapper)) {
  $exit(true);
}

require_once $bootstrapper;
require_once PFAD_ROOT.PFAD_INCLUDES_MODULES.'PaymentMethod.class.php';
require_once PFAD_ROOT . PFAD_CLASSES . 'class.JTL-Shop.Bestellung.php';

$oPlugin = Plugin::getPluginById('mcpay_mircopayment');

if ($oPlugin === null) {
  die('McPay Plugin cant be found.');
  $exit(true);
}

if (!empty($_POST['action'])){

  $ccardActions = array('transactionRefund', 'transactionChargeback', 'transactionBackpay');
  $ccardNegActions = array('transactionRefund', 'transactionChargeback');

  if (in_array($_POST['action'], $ccardActions)) {
    // get order id from zahlungsession
    $sql = 'SELECT `kBestellung` FROM `tzahlungsession` WHERE `cZahlungsID` = "'.$_POST['freeParam']['cZahlungsID'].'" ';
    $zsObj = Shop::DB()->query($sql, 1);
    //mail('webmaster@web-dezign.de', __FILE__.'->$zsObj', print_r($zsObj,1));
    $bestID = $zsObj->kBestellung;

    // ccard payin
    require_once str_replace('frontend', 'paymentmethod', $oPlugin->cFrontendPfad).'/class.micropayment_ccard.php';
    $payment = new micropayment_ccard();
    $config = $payment->getPluginConf('', $oPlugin);
    $payment->McPay->switchPaymethod('ccard');

    $order = new Bestellung($bestID, TRUE);
    //mail('webmaster@web-dezign.de', __FILE__.'->$order', print_r($order,1));

    $incomingPayment           = new stdClass();
    if (in_array($_POST['action'], $ccardNegActions)){
      $incomingPayment->fBetrag  = ($_POST['amount'] / 100) * -1;
    } else {
      $incomingPayment->fBetrag  = ($_POST['amount'] / 100);
    }
    $incomingPayment->cISO     = $order->Waehrung->cISO;
    $incomingPayment->cHinweis = $_POST['transactionId'];

    $payment->addIncomingPayment($order, $incomingPayment);
    if ($_POST['action'] == 'transactionBackpay'){
      $payment->setStatus(BESTELLUNG_STATUS_IN_BEARBEITUNG, $order->cBestellNr);
    } else if ($_POST['action'] == 'transactionChargeback'){
      $payment->setStatus(BESTELLUNG_STATUS_STORNO, $order->cBestellNr);
    } else {
      $payment->setStatus(BESTELLUNG_STATUS_IN_BEARBEITUNG, $order->cBestellNr);
    }
  }

  $sepaActions = array('transactionCreate');
  $sepaTypes = array('BOOKING', 'REFUND', 'REVERSAL', 'BACKPAY');
  $prepayTypes = array('REFUND', 'PAYIN');
  $sepaNegTypes = array('REFUND', 'REVERSAL', 'EXPIRE');

  // check if sepa or prepay
  $sessPrefix = strtolower(substr($_POST['sessionId'],0,3));
  $isPrepay = false;
  if (in_array($sessPrefix, array('ph-', 'sh-'))){
    $isPrepay = true;
  }

  if (in_array($_POST['action'], $sepaActions)) {
    $createIncomingPayment = true;
    if ($isPrepay){
      // prepay payin
      require_once str_replace('frontend', 'paymentmethod', $oPlugin->cFrontendPfad).'/class.micropayment_prepay.php';
      $payment = new micropayment_prepay();
      $config  = $payment->getPluginConf('', $oPlugin);
      $payment->McPay->switchPaymethod('prepay');
      if (!in_array($_POST['type'], $prepayTypes)){
        $createIncomingPayment = false;
      }
    } else {
      // sepa payin
      require_once str_replace('frontend', 'paymentmethod', $oPlugin->cFrontendPfad).'/class.micropayment_sepa.php';
      $payment = new micropayment_sepa();
      $config  = $payment->getPluginConf('', $oPlugin);
      $payment->McPay->switchPaymethod('sepa');
    }

    $sessionInfo = $payment->McPay->sessionGet($_POST['sessionId']);
    //mail('webmaster@web-dezign.de', __FILE__.'->$sessionInfo', print_r($sessionInfo,1));
    
    if (!empty($sessionInfo->freeParams['cZahlungsID'])) {
      // get order id from zahlungsession
      if ($sessPrefix == 'ph-'){
        $sql = 'SELECT `kBestellung` FROM `tzahlungsid` WHERE `cId` = "'.$sessionInfo->freeParams['cZahlungsID'].'" ';
      } else {
        $sql = 'SELECT `kBestellung` FROM `tzahlungsession` WHERE `cZahlungsID` = "'.$sessionInfo->freeParams['cZahlungsID'].'" ';
      }
      //echo $sql;
      $zsObj = Shop::DB()->query($sql, 1);
      //mail('webmaster@web-dezign.de', __FILE__.'->$zsObj', print_r($zsObj,1));
      $bestID = $zsObj->kBestellung;
      if (!empty($bestID)) {
        $order = new Bestellung($bestID, TRUE);
        //mail('webmaster@web-dezign.de', __FILE__.'->$order', print_r($order,1));

        $amount = $_POST['amount'];
        if (!empty($_POST['paidAmount'])){
          $amount = $_POST['paidAmount'];
        }

        if ($createIncomingPayment) {
          $incomingPayment           = new stdClass();
          $incomingPayment->fBetrag  = ($amount / 100);
          $incomingPayment->cISO     = $order->Waehrung->cISO;
          $incomingPayment->cHinweis = $_POST['transactionId'];
          if (in_array($_POST['type'], $sepaNegTypes)) {
            $incomingPayment->cHinweis .= ' ('.$_POST['type'].')';
          }
          if ($sessionInfo->openAmount > 0) {
            $incomingPayment->cHinweis .= ' '.($sessionInfo->openAmount / 100).' EUR open';
          }
          $payment->addIncomingPayment($order, $incomingPayment);
          if ($sessionInfo->openAmount <= 0 && $sessionInfo->status == 'PAID') {
            $payment->setOrderStatusToPaid($order);
            $payment->sendConfirmationMail($order);
          }
        }

        //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$order', print_r($order,1));
        if ($order->cStatus != BESTELLUNG_STATUS_STORNO) { // edit not cancelled orders only
          if ($_POST['type'] == 'BACKPAY') {
            $payment->setStatus(BESTELLUNG_STATUS_IN_BEARBEITUNG, $order->cBestellNr);
          } else if ($_POST['type'] == 'REVERSAL') {
            $payment->setStatus(BESTELLUNG_STATUS_STORNO, $order->cBestellNr);
          } else if ($_POST['type'] == 'EXPIRE') {
            $payment->setStatus(BESTELLUNG_STATUS_STORNO, $order->cBestellNr);
          } else if ($_POST['type'] == 'PAYIN' && $sessionInfo->openAmount <= 0 && $sessionInfo->status == 'PAID') {
            $payment->setStatus(BESTELLUNG_STATUS_BEZAHLT, $order->cBestellNr);
          } else if ($_POST['type'] == 'PAYIN' && $sessionInfo->openAmount <= 0 && $sessionInfo->status == 'CLOSED') {
            $payment->setStatus(BESTELLUNG_STATUS_STORNO, $order->cBestellNr);
          } else if (!$isPrepay && $_POST['type'] == 'BOOKING'){
            $payment->setStatus(BESTELLUNG_STATUS_BEZAHLT, $order->cBestellNr);
          } else {
            $payment->setStatus(BESTELLUNG_STATUS_IN_BEARBEITUNG, $order->cBestellNr);
          }
        }
      }
    }
  }

}

if (!empty($_GET['sh'])){
  require_once str_replace('frontend', 'paymentmethod', $oPlugin->cFrontendPfad).'/class.micropayment_ccard.php';
  $payment = new micropayment_ccard();
  //echo '<pre>'.print_r($payment,1).'</pre>';
  $McPay = new mcpay();

  $payment->duringCheckout = true;
  $url = $payment->getNotificationURL($_GET['sh']);
  
  $res = $McPay->doCall($url, $_GET);

  $sql = 'SELECT * FROM `tzahlungsession` WHERE `cZahlungsID` = "'.str_replace('_', '', $_GET['sh']).'" ';
  $zsObj = Shop::DB()->query($sql, 1);
  //mail('webmaster@web-dezign.de', __FILE__.'->$zsObj', $url.print_r($res,1).print_r($zsObj,1));
  $bestID = $zsObj->kBestellung;
  if (empty($bestID)){
    die('Cant load order id with hash '.$_GET['sh']);
  }
  //echo '<pre>'.print_r($bestID,1).'</pre>';
  $order = new Bestellung($bestID, true);
  //echo '<pre>'.print_r($order,1).'</pre>';
  //mail('webmaster@web-dezign.de', __FILE__.'->$order', print_r($order,1));
  $url   = $payment->getReturnURL($order);

  $crlf = "\r\n";
  $return = 'status=ok'.$crlf // ok  | error
    .'url='.$url.$crlf
    .'target=_top'.$crlf
    .'forward=1'.$crlf
    .'message=OK'.$crlf;
  echo $return;
  exit();
}

if (!empty($_GET['orderid'])) {
  session_id($_GET['sessId']);
  $session = Session::getInstance(TRUE, TRUE, $_GET['sessName']);

  $p = explode('-', $_GET['orderid']);
  //echo '<pre>'.print_r($p,1).'</pre>';
  $orderId = $p[0];
  $custId  = $p[1];
  $sql     = 'SELECT `kBestellung` FROM `tbestellung` WHERE `cBestellNr` = "'.(int)$orderId.'" ';
  //echo $sql;
  $paymentHash = $_GET['ph'];

  $bestObj = Shop::DB()->query($sql, 1);
  if (empty($bestObj)) {
    die('Cant load order number '.$orderId);
  }
  $bestID = $bestObj->kBestellung;
  if (empty($bestID)) {
    die('Cant load order id '.$orderId);
  }
  //echo '<pre>'.print_r($bestID,1).'</pre>';
  $order = new Bestellung($bestID, TRUE);
  //echo '<pre>'.print_r($order,1).'</pre>';
  //mail('webmaster@web-dezign.de', __FILE__.'->$order', print_r($order,1));

  $sql     = 'SELECT `cModulId` FROM `tzahlungsart` WHERE `kZahlungsart` = "'.(int)$order->kZahlungsart.'"';
  $zahlObj = Shop::DB()->query($sql, 1);
  if (empty($zahlObj->cModulId)) {
    die('Cant load paymethod cModulId.');
  }

  //echo $zahlObj->cModulId;
  $paymentMethod = PaymentMethod::create($zahlObj->cModulId);
  //echo '<pre>'.print_r($paymentMethod,1).'</pre>';
  //$url = $paymentMethod->getNotificationURL($paymentHash);  echo $url; exit();

  if (isset($paymentMethod)) {
    $paymentMethod->handleNotification($order, $paymentHash, $_REQUEST);
    if ($paymentMethod->redirectOnPaymentSuccess() === TRUE) {
      header('Location: '.$paymentMethod->getReturnURL($order));
      exit();
    }
  }

} else if (!empty($_GET['function'])&& $_GET['function'] == 'custinfo') {
  $crlf = "\n";
  require_once str_replace('frontend', 'paymentmethod', $oPlugin->cFrontendPfad).'/class.micropayment_ccard.php';
  $payment = new micropayment_ccard();
  $config = $payment->getPluginConf('', $oPlugin);
  //echo '<pre>'.print_r($config,1).'</pre>';
  $accessKey = $config['accessKey'];
  if ($accessKey == $_GET['ak']) {
    if (!empty($_GET['log'])) {
      $McPay = new mcpay();
      echo $McPay->readerLogFile($McPay->log->error_log);
      //echo $McPay->readLogFile($McPay->log->error_log, TRUE);
      exit();
    } else {
      $infos  = 'Shopversion: '.(string)(JTL_VERSION/100).'.'.JTL_MINOR_VERSION.'<br>';
      $infos  .= 'Pluginversion: '.implode('.', str_split((string)$oPlugin->nVersion)).'<br>';
      echo '<pre>'.print_r($infos, 1).'</pre>';
      echo '<pre>CFG:'.print_r($config, 1).'</pre>';
      $sql     = 'SELECT * FROM `tzahlungsart` WHERE `cAnbieter` = "Micropayment"';
      $zahlObj = Shop::DB()->query($sql, 2);
      echo '<pre>'.print_r($zahlObj,1).'</pre>';
      $return = '';
    }
  } else {
    $return = 'status=error'.$crlf.'message=Access denied!';
  }

} else {

  if (!empty($_POST['action'])){
    $crlf = "\r\n";
    $return = 'status=ok'.$crlf // ok  | error
    .'action='.$_POST['action'].$crlf;
    if (!empty($_POST['type'])){
      $return.= 'type='.$_POST['type'].$crlf;
    }
    echo $return;
    exit();
  }
  echo 'FAIL';
}
exit();
?>