<?php
require_once('class.micropayment_base.php');

class micropayment_ccard extends micropayment_base
{
  var $pm = 'ccard'; // important for event url
  var $paymethod = 'ccard_api';

  /**
   * handleAdditional
   *
   * @param array $req
   *
   * @return bool
   */
  function handleAdditional($req)
  {
    $_SESSION['mcpay_error'] = array();
    //echo '<pre>'.print_r($req, 1).'</pre>';
    //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$req', print_r($req,1));

    if (empty($_SESSION['Zahlungsart']->nWaehrendBestellung)){
        return true; // hide zusatzschritt if after order
    }
    // load texts
    $this->loadTexts();

    if (!empty($req['zahlungsartzusatzschritt'])) {
      if (!empty($req['mcpay_card_reuse']) && $req['mcpay_card_reuse'] != 'new') {
        // no inputs needed
        $_SESSION['mcpay']['CardReuse'] = TRUE;
      } else {
        $_SESSION['mcpay']['CardReuse'] = FALSE;

        // holder
        if (empty($req['mcpay_card_holder'])) {
          $_SESSION['mcpay_error'][] = $this->getText('mcpayCardHolderError', 'Card Holder is mandatory.');
        } else {
          $_SESSION['mcpay']['CardHolder'] = $req['mcpay_card_holder'];
        }
        // pan
        if (empty($req['mcpay_card_pan'])) {
          $_SESSION['mcpay_error'][] = $this->getText('mcpayCardPanError', 'Card Pan is mandatory.');
        } else {
          $_SESSION['mcpay']['CardPan'] = $req['mcpay_card_pan'];
        }
        // month
        if (empty($req['mcpay_card_month'])) {
          $_SESSION['mcpay_error'][] = $this->getText('mcpayExpireMonthError', 'Expire Month is mandatory.');
        } else {
          $_SESSION['mcpay']['CardMonth'] = $req['mcpay_card_month'];
        }
        // year
        if (empty($req['mcpay_card_year'])) {
          $_SESSION['mcpay_error'][] = $this->getText('mcpayExpireYearError', 'Expire Year is mandatory.');
        } else {
          $_SESSION['mcpay']['CardYear'] = $req['mcpay_card_year'];
        }
        // cvc
        if (empty($req['mcpay_card_cvc'])) {
          $_SESSION['mcpay_error'][] = $this->getText('mcpayCardCVCError', 'Card CVC is mandatory.');
        } else {
          $_SESSION['mcpay']['CardCVC'] = $req['mcpay_card_cvc'];
        }
        // token
        if (empty($req['mcpay_card_token']) && empty($_SESSION['mcpay_error'])) {
          $_SESSION['mcpay_error'][] = $this->getText('mcpayCardTokenError', 'Card Token is mandatory.');
        } else {
          $_SESSION['mcpay']['CardToken'] = $req['mcpay_card_token'];
        }

        // save paymethod
        if (!empty($req['mcpay_card_remember'])) {
          // save before using card
          //$res = $this->setPaydata('ccard', $_SESSION['mcpay']);
          //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$res', print_r($res,1).$this->paymethod);
          $_SESSION['mcpay']['CardRemember'] = TRUE;
        } else {
          $_SESSION['mcpay']['CardRemember'] = FALSE;
        }
      }


      // error handling
      if (empty($_SESSION['mcpay_error'])) {
        return TRUE; // hide zusatzschritt
      } else {
        //echo '<pre>'.print_r($_SESSION['mcpay_error'], 1).'</pre>';
        $error_msg = '';
        foreach ($_SESSION['mcpay_error'] AS $k => $v) {
          $error_msg .= $v.'<br>';
        }

        global $smarty;
        $smarty->assign('error_msg', $error_msg);
      }
    }

    $this->preparePaymentProcess(FALSE);
    return FALSE; // show zusatzschritt
  }

  function validateAdditional()
  {
    return TRUE;
  }

  /**
   * preparePaymentProcess
   *
   * @param \Bestellung $order
   *
   * @return bool|void
   */
  function preparePaymentProcess($order)
  {
    global $smarty;

    $config = $this->getPluginConf($order);
    //echo '<pre>'.print_r($config,1).'</pre>';
    //echo '<pre>'.print_r($order,1).'</pre>';

    if (empty($_SESSION['Zahlungsart']->nWaehrendBestellung) && empty($_SESSION['mcpay'])){
      //$order = false;
    }

    if (!$order) { // form zusatzschritt
      if (!empty($_SESSION['mcpay'])) {
        unset($_SESSION['mcpay']);
      }
      $tpl = $this->getMyForm($config, $order);
      //echo '<pre>'.print_r($_SESSION['mcpay'], 1).'</pre>';

      $smarty->assign('micropayment_style', $config['plugin_urlshop'].'/mcpayGetStyle?sn=');
      $smarty->assign('micropayment_scripturl', $config['plugin_urlshop'].'/mcpayGetScript?sn=');
      $smarty->assign('micropayment_formid', $config['payformid']);
      $smarty->assign('micropayment_iframe', $tpl);
      $smarty->assign('micropayment_logo', $this->McPay->iconURLs['ccard']);

    } else { // book
      $userData = $this->getUserDataFromOrder($order, $config);
      //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$userData', print_r($userData,1));
      //echo '<pre>'.print_r($userData, 1).'</pre>';

      $hash = $this->generateHash($order);
      if ($order->cId != '') $hash = $order->cId;

      $notifyURL               = $this->getNotificationURL($hash).'&mcpaySessID=';
      $config['returnURL']     = $notifyURL;
      $config['returnURLNO3D'] = $notifyURL;
      $config['payload']['cZahlungsID'] = str_replace('_', '', $hash);
      $config['autogenSession'] = true; // auto create session on MCP

      $payData = array(
        'holder'   => $_SESSION['mcpay']['CardHolder'],
        'month'    => $_SESSION['mcpay']['CardMonth'],
        'year'     => $_SESSION['mcpay']['CardYear'],
        'pan'      => $_SESSION['mcpay']['CardPan'],
        'cvc'      => $_SESSION['mcpay']['CardCVC'],
        'token'    => $_SESSION['mcpay']['CardToken'],
        'remember' => $_SESSION['mcpay']['CardRemember'],
      );

      $return          = new stdClass();
      $return->forward = TRUE;

      try {

//        mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$userData', print_r($userData,1));
//        mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$config', print_r($config,1));
//        mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$payData', print_r($payData,1));


        if ($_SESSION['mcpay']['CardReuse']) {
          //$res = $this->McPay->reuseCard($userData, $config);
          $payData['reuse'] = TRUE;
          $payData['token'] = TRUE;
        } else {
          //$res = $this->McPay->bookCCard($userData, $config, $payData);
          $payData['reuse'] = FALSE;
        }
        $res = $this->McPay->bookCCard($userData, $config, $payData);
        if ($this->McPay->debug) $this->McPay->log->log(__CLASS__.'->'.__FUNCTION__, $res); // log result
        $_SESSION['mcpay']['TrxResult'] = $res; // save result into session

        //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$_SESSION', print_r($_SESSION['mcpay'],1));

        $return->res = $res; // return result too
        if (!empty($res->forward)) {
          header('Location: '.$res->forwardURL);
          exit();
          //$return->url = $res->forwardURL;
          //return $return;
        }

      } catch (Exception $e) {
        if ($this->McPay->debug) $this->McPay->log->log(__CLASS__.'->'.__FUNCTION__, $e->getMessage()); // log error
        //echo '<pre>'.print_r($_SESSION['mcpay']['tracking']['chkSumData'],1).'</pre>';
        $logo = mcpay::getPoweredBy(FALSE, $_SESSION['mcpay']['tracking']['chkSumData'], 0, $e->getMessage(), TRUE);
        $_SESSION['mcpay']['lastError'] = $e->getMessage().$logo;
        header('Location: bestellvorgang.php');
        die($e->getMessage());
      }
    }
  }

  /**
   * getMyForm
   *
   * @param $conf
   *
   * @return string
   */
  function getMyForm($conf, $order)
  {
    $this->McPay->setConfig($conf);
    //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$conf', print_r($conf,1));
    $filename = $conf['plugin_pathview'].'/mcpay_form_ccard.tpl';

    $prefillData = array();
    $res         = $this->getPaydata('ccard');
    //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$res', print_r($res,1));
    if (!empty($res[0])) {
      foreach ($res AS $k => $v) {
        $payDat = unserialize($v['data']);
        //echo '<pre>'.print_r($payDat,1).'</pre>';
        $prefillData['use_'.$k] = array(
          //'filldesc' => $token->get_display_name(),
          'token'   => $payDat['CardToken'],
          'holder'  => $payDat['CardHolder'],
          'pan'     => $payDat['CardPan'],
          'month'   => $payDat['CardMonth'],
          'year'    => $payDat['CardYear'],
          'brand'   => $payDat['CardBrand'],
          'checked' => 'checked',
        );
      }
    }

    // Template Translations
    $translation = array(
      'Name on Card'                => $this->getText('mcpayCardHolder', 'Account Holder'),
      'Remember Data'               => $this->getText('mcpayRememberCard', 'Remember Account for future purchase'),
      'Use new Card'                => $this->getText('mcpayUseNewCard', 'Use new Account'),
      'Use old Card'                => $this->getText('mcpayUseOldCard', 'Use old Account'),
      /*
      'Holder'                      => $this->getText('mcpay_', 'Holder'),
      'IBAN'                        => $this->getText('mcpay_', 'IBAN'),
      'BIC'                         => $this->getText('mcpay_', 'BIC'),
      'Remove'                      => $this->getText('mcpay_', 'Remove'),
      */
      'Please check your inputs!'   => $this->getText('mcpayCheckInputsError', 'Please check your inputs!'),
      'Vorname Nachname'            => $this->getText('mcpayFirstLastname', 'Firstname Lastname'),
      'Credit Card Number'          => $this->getText('mcpayCardNumber', 'Card Number'),
      'Expiration Date'             => $this->getText('mcpayExpDate', 'ExpDate'),
      'Card CVC'                    => $this->getText('mcpayCVC', 'CVC'),
      'Month'                       => $this->getText('mcpayMonth', 'Month'),
      'Year'                        => $this->getText('mcpayYear', 'Year'),
      'NAME'                        => $this->getText('mcpayCardHolder', 'Account Holder'),
      'PAN'                         => $this->getText('mcpayCardNumber', 'Card Number'),
      'EXPIRE'                      => $this->getText('mcpayExpDate', 'ExpDate'),
    );

    $options = array(
      'showCardOnly'    => FALSE, // disable radio button for cards
      'hideImg'         => TRUE,  // hide logo
      'futureYears'     => 10,
      'preSeletActDate' => FALSE,
      'showMonthNames'  => FALSE,
      'showRemember'    => TRUE,
      'showRemove'      => FALSE,
      'cardStyle'       => TRUE,
      'cardSelect'      => FALSE,
      'specialBrand'    => FALSE,
      'specialHolder'   => FALSE,
      'prefillPost'     => $_POST,
    );
    if (!empty($_POST['mcpay_card_reuse']) && $_POST['mcpay_card_reuse'] == 'new'){
      $options['preselectNewCard'] = TRUE;
    }

    $formTPL = $this->McPay->getCCardTPL($filename, $options, $prefillData, $translation);
    $output  = $formTPL;

    $output .= '<script>';
    if ($this->McPay->debug) {
      $output .= 'console.log("MCPAY ModelCCard START"); ';
    }

    $payFormID  = $conf['payformid'];
    $inlineCode = $this->McPay->getStartJS(TRUE, FALSE, $this->McPay->debug, $payFormID);
    $output     .= 'mcpay_ccard_execute(); ';
    $output     .= $inlineCode.' ';

    if ($this->McPay->debug) {
      $output .= 'console.log("MCPAY ModelCCard END"); ';
    }
    $output .= '</script>';

    return $output;
  }

  /**
   * handleNotification
   *
   * @param \Bestellung $order
   * @param string      $paymentHash
   * @param array       $args
   * @param bool        $returnURL
   *
   * @return string|void
   */
  function handleNotification($order, $paymentHash, $args, $returnURL = FALSE)
  {
    //$args = func_get_args();
    //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$args', print_r($args, 1));

    /*
    // bestellstati
    define('BESTELLUNG_STATUS_STORNO', -1);
    define('BESTELLUNG_STATUS_OFFEN', 1);
    define('BESTELLUNG_STATUS_IN_BEARBEITUNG', 2);
    define('BESTELLUNG_STATUS_BEZAHLT', 3);
    define('BESTELLUNG_STATUS_VERSANDT', 4);
    define('BESTELLUNG_STATUS_TEILVERSANDT', 5);
     */

    $return = new stdClass();

    $crlf     = "\r\n";
    $errorMsg = '';
    $sessID   = '';
    if (!empty($args['mcpaySessID'])) {
      $sessID = $args['mcpaySessID'];
    }
    try {
      // with 3D Secure
      if (!empty($args['check3dId'])) {
        $check3dId = $args['check3dId'];
        $config    = $this->getPluginConf($order);
        $res       = $this->McPay->verify3D($check3dId, $config);
        if (isset($res->error) && $res->error == 0) {
          $post = array(
            'action'        => 'transactionCreate',
            'type'          => 'BOOKING',
            'sessionId'     => $res->sessionId,
            'transactionId' => $res->transactionId,
            'testMode'      => $config['testMode'],
          );
          $tmp  = $this->responseCCard3DAction($post, $order);
          $tmp = str_replace("\n", '&', $tmp);
          $parsed = array();
          parse_str($tmp, $parsed);
          //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->responseCCard3DAction with 3D', print_r($tmp, 1).print_r($parsed,1));
          $return->forward = 1;
          $return->forwardURL = $parsed['url'];
        } else {
          $errorMsg = $res->transactionResultMessage;
        }

        // without 3D Secure
      } else if (!empty($sessID)) {
        $config = $this->getPluginConf($order);
        $res    = $this->McPay->sessionGet($sessID);
        //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->sessionGet', print_r($res, 1));
        if ($res->status == 'SUCCESS') {
          $post = array(
            'action'        => 'transactionCreate',
            'type'          => 'BOOKING',
            'sessionId'     => $sessID,
            'transactionId' => $res->transactionIds[0],
            'testMode'      => $config['testMode'],
          );
          $tmp  = $this->responseCCard3DAction($post, $order);
          $tmp = str_replace("\n", '&', $tmp);
          $parsed = array();
          parse_str($tmp, $parsed);
          //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->responseCCard3DAction without 3D', print_r($tmp, 1).print_r($parsed,1));
          $return->forward = 1;
          $return->forwardURL = $parsed['url'];
        } else {
          $errorMsg = 'Session failed with status: '.$res->status;
        }

        // failed
      } else {
        $errorMsg = '3D Secure failed!';
      }
    } catch (Exception $e) {
      if ($this->McPay->debug) $this->McPay->log->log(__CLASS__.'->'.__FUNCTION__, $e->getMessage()); // log error
      $errorMsg = $e->getMessage();
    }

    if (!empty($errorMsg)){
      $url = $this->getReturnURL($order).'&mcpayerror='.$errorMsg;
      $return->forward = 1;
      $return->forwardURL = $url;
    }

    //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$return', print_r($return,1));
    if ($this->McPay->debug) $this->McPay->log->log(__CLASS__.'->'.__FUNCTION__, print_r($return,1));
    if ($returnURL) return $return->forwardURL;
    return $return;
  }

  /**
   * redirectOnPaymentSuccess
   *
   * @return bool
   */
  function redirectOnPaymentSuccess()
  {
    //$args = func_get_args();
    //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->$args', print_r($args,1));
    //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->session', print_r($_SESSION['mcpay'],1));

    // save paymethod
    if (!empty($_SESSION['mcpay']['CardRemember'])) {
      // save on success to be sure ccard is valid and saved in mcp system
      $res = $this->setPaydata('ccard', $_SESSION['mcpay']);
      //mail('webmaster@web-dezign.de', __CLASS__.'->'.__FUNCTION__.'->Paydata saved', print_r($_SESSION['mcpay'],1).$this->paymethod);
    }

    return TRUE;
  }

  /**
   * responseCCard3DAction
   *
   * @param $post
   * @param $order
   *
   * @return string
   */
  public function responseCCard3DAction($post, $order)
  {
    $crlf   = "\r\n";
    $return = '';

    // check mandatory params
    if (empty($post['action'])) $return = 'status=error'.$crlf.'message=action missing.';
    else                              $act = $post['action'];

    if (empty($post['type'])) $return = 'status=error'.$crlf.'message=type missing.';
    else                              $type = $post['type'];

    if (empty($post['sessionId'])) $return = 'status=error'.$crlf.'message=sessionId missing.';
    else                              $sessID = $post['sessionId'];

    if (empty($post['transactionId'])) $return = 'status=error'.$crlf.'message=transactionId missing.';
    else                              $trxID = $post['transactionId'];

    if (empty($post['testMode'])) $return = 'status=error'.$crlf.'message=Testmode missing.';
    else                              $testmode = $post['testMode'];

    // return error if some is right there
    if (!empty($return)) {
      if (empty($post)) {
        echo $return;
      }
      return $return;
    }
    // default error after pre-checks
    $return = 'status=error'.$crlf.'message=Unknown Error';

    if ($act == 'transactionCreate') {
      if ($this->McPay->debug) $this->McPay->log->debug(__CLASS__.'->'.__FUNCTION__.'->GET: '.print_r($_GET, 1).' POST: '.print_r($_POST, 1).' $post: '.print_r($post, 1));

      switch ($type) {
        // CCard callbacks
        case 'BOOKING': // normal trx
          // Response Testmode Comment
          if (!empty($testmode)) {
            //$order->addStatusHistoryComment('!! TEST MODE !!', $payment->getPaymentState());
          }
          $url = $this->getReturnURL($order);

          $incomingPayment           = new stdClass();
          $incomingPayment->fBetrag  = $order->fGesamtsummeKundenwaehrung;
          $incomingPayment->cISO     = $order->Waehrung->cISO;
          $incomingPayment->cHinweis = $trxID;

          $this->addIncomingPayment($order, $incomingPayment);
          $this->setOrderStatusToPaid($order);
          $this->sendConfirmationMail($order);
          $this->updateNotificationID($order->kBestellung, $_GET['ph']);

          $return = 'status=ok'.$crlf // ok  | error
            .'url='.$url.$crlf
            .'target=_top'.$crlf
            .'forward=1'.$crlf
            .'message=OK'.$crlf;

          break;

      }

      if ($this->McPay->debug) $this->McPay->log->debug(__CLASS__.'->'.__FUNCTION__.'->return: '.print_r($return, 1));
    }
    return $return;
  }
}

?>